/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2002-2008 by Y.D.K Co.,Ltd
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_sil.h 1433 2009-01-21 15:43:24Z ydkinc-matsumoto $
 */

/*
 *  sil.hΥץå¸Microblazeѡ
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

/*
 *  ץåΥǥ
 */
#define SIL_ENDIAN_BIG

#ifndef TOPPERS_MACRO_ONLY

/*
 *  NMI٤Ƥγߤζػ
 */
Inline uint8_t
TOPPERS_disint(void)
{
	uint32_t  TOPPERS_msr;

	Asm("mfs %0,rmsr": "=r"(TOPPERS_msr));
	Asm("mts rmsr,%0" : : "r"(TOPPERS_msr & ~(0x0002)) : "memory");
    return((uint8_t)(TOPPERS_msr & (0x0002)));
}

/*
 *  ͥ٥ޥɽˤθͤ
 */
Inline void
TOPPERS_set_iipm(uint8_t TOPPERS_ie_bit)
{
    uint32_t  TOPPERS_msr;

	Asm("mfs %0,rmsr": "=r"(TOPPERS_msr));
	TOPPERS_msr = TOPPERS_msr & ~(0x0002);
	TOPPERS_msr = TOPPERS_msr | (TOPPERS_ie_bit & (0x0002));
	Asm("mts rmsr,%0" : : "r"(TOPPERS_msr) : "memory");
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC      uint8_t TOPPERS_ie_bit
#define SIL_LOC_INT()    ((void)(TOPPERS_ie_bit = TOPPERS_disint()))
#define SIL_UNL_INT()    (TOPPERS_set_iipm(TOPPERS_ie_bit))

/*
 *  Ԥprc_support.S
 */
extern void sil_dly_nse(ulong_t dlytim);

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_SIL_H */
