/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: integrator_ap_uart.h 15 2006-10-30 07:37:23Z honda $
 */

/*
 *   ARM PrimCell UART ʰSIOɥ饤
 */

#ifndef TOPPERS_ARM_PRIMECELL_UART_H
#define TOPPERS_ARM_PRIMECELL_UART_H

/*
 *  ꥢI/Oݡȿ
 */
#define TNUM_SIOP		1		/* ݡȤ륷ꥢI/OݡȤο */


#ifndef TOPPERS_MACRO_ONLY

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND    1U        /* ǽХå */
#define SIO_RDY_RCV    2U        /* ΥХå */

/*
 * UARTΥ쥸
 */
#define UART_DR     0x00  /* ǡ쥸 */
#define UART_RSR    0x04  /* ơ쥸 */
#define UART_TECR   0x04  /* 顼ꥢ쥸 */
#define UART_FR     0x18  /* ե饰쥸 */
#define UART_IBRD   0x24  /* ܡ졼ȥ쥸 */
#define UART_FBRD   0x28  /* ʬܡ졼ȥ쥸 */
#define UART_LCR_H  0x2C  /* 饤󥳥ȥ쥸(H) */
#define UART_CR     0x30  /* ȥ쥸 */
#define UART_IFLS   0x34  /* FIFO٥쥸 */
#define UART_IMSC   0x38  /* ߥޥ쥸 */
#define UART_RIS    0x3C  /* ߥơ쥸 */
#define UART_MIS    0x40  /* ޥߥơ쥸 */
#define UART_ICR    0x44  /* ߥꥢ쥸 */

#define UART_LCR_H_FEN       0x10  /* FIFOͭ */
#define UART_LCR_H_WLEN_8    0x60  /* 8bitĹ       */

#define UART_CR_RXE    0x0200   /* ͭ */
#define UART_CR_TXE    0x0100   /* ͭ */
#define UART_CR_UARTEN 0x0001   /* UARTͭ */

#define UART_FR_TXFF 0x20     /* Хåեեʤ"1"     */
#define UART_FR_RXFE 0x10     /* ͭʥǡʤ"1" */

#define UART_IMSC_RXIM 0x0010 /* ߥޥ          */
#define UART_IMSC_TXIM 0x0020 /* ߥޥ          */


/*
 *  SIOɥ饤Фν롼
 */
extern void arm_primecell_uart_initialize(void);

/*
 *  ץ󤷤ƤݡȤ뤫
 */
extern bool_t arm_primecell_uart_openflag(void);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB *arm_primecell_uart_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void arm_primecell_uart_cls_por(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern bool_t arm_primecell_uart_snd_chr(SIOPCB *siopcb, char_t c);

/*
 *  ꥢI/OݡȤʸ
 */
extern int_t arm_primecell_uart_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void  arm_primecell_uart_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void arm_primecell_uart_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  SIOγߥӥ롼
 */
extern void arm_primecell_uart_isr(void);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void arm_primecell_uart_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void arm_primecell_uart_irdy_rcv(intptr_t exinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_ARM_PRIMECELL_UART_H */
